#  V812.defn.tcl

proc {Add_CAEN V812_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   for {set i 0} {$i < 16} {incr i} {
      define-vme-register $name xVME Threshold$i      "-a$A32addrbase -w32 -o[expr $i+$i] -pwo -d16 -l8 -b0 -zd -i16"
      define-vme-register $name xVME Enable$i         "-a$A32addrbase -w32 -o0x4a -pwo -d16 -l1 -b$i -zd"
   }
 
   define-vme-register $name xVME OutputWidthL        "-a$A32addrbase -w32 -o0x40 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME OutputWidthH        "-a$A32addrbase -w32 -o0x42 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME DeadTimeL           "-a$A32addrbase -w32 -o0x44 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME DeadTimeH           "-a$A32addrbase -w32 -o0x46 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME MajorityThreshold   "-a$A32addrbase -w32 -o0x48 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Enable              "-a$A32addrbase -w32 -o0x4a -pwo -d16 -l0 -b0 -zx -i0xffff"
   define-vme-register $name xVME Test                "-a$A32addrbase -w32 -o0x4c -pwo -d16 -l0 -b0 -zx"

   define-vme-register $name xVME ModID#1              "-a$A32addrbase -w32 -o0xfe -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#2              "-a$A32addrbase -w32 -o0xfc -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#3              "-a$A32addrbase -w32 -o0xfa -pro -d16 -l0 -b0 -zx"
}


proc {CAEN V812_DAQ-reset} {args} {
#   V812
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ModID#1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {CAEN V812_DAQ-flush} {args} {
#   V812
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V812_DAQ-go} {args} {
#   V812
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V812_DAQ-halt} {args} {
#   V812
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V812_DAQ-setup} {args} {
#   V812
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {CAEN V812_registersavepatterns} {Threshold* OutputWidthL OutputWidthH DeadTimeL DeadTimeH MajorityThreshold Enable}


